#include <stdio.h>
//#include <libspe.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#define SPE_NUM 6

typedef enum
{
	ML_DOING,
	ML_DONE,
	ML_FREE,
}
mlstate_t;

typedef struct
{
	double *focus;
	mlstate_t flag;
}
matline_t;

typedef struct
{
	double *max;
	int idx;
}
mlfocus_t;

static volatile double result[SPE_NUM][2048] __attribute__ ((aligned (128)));

#define matal(n, m) mat[m*4 + n]

#ifdef LIBMAIN
int
main(int argc, char** argv)
{
	int lc;
	double mat[16] = { 1,  1,  0,  3,
				        2,  1, -1,  1,
				        3, -1, -1,  2,
				        -1, 2,  3, -1,};	
	int m = 4, n = 4;
	
	for(lc = 0; lc < m*n; lc++)
	{
		printf(" %lf", mat[lc]);
		if((lc % n) == (n-1)){
			printf("\n");
		}
	}
	
	lu_decomposition(mat, m, n);

			printf("\n");
	
	for(lc = 0; lc < m*n; lc++)
	{
		printf(" %lf", mat[lc]);
		if((lc % n) == (n-1)){
			printf("\n");
		}
	}
	
	
}
#endif


int
lu_decomposition (double *mat, int m, int n)
{
	int lc, lc2, pivot;
	int rline, fline, sline;
	matline_t ml[n], dml[n], tml;
	mlfocus_t mf;

	// initialize matline
	mf.max = &(mat[0]);
	mf.idx = 0;
	pivot = 0;
	rline = m;
	for (lc = 0; lc < n; lc++) {
		ml[lc].focus = &(mat[m * lc]);
		ml[lc].flag = ML_FREE;

#ifdef EX4PIVOT
		if (*(mf.max) < *(ml[lc].focus)) {
			mf.max = ml[lc].focus;
			mf.idx = lc;
		}
#endif
	}

#ifdef EX4PIVOT
	tml = ml[0];
	ml[0] = ml[mf.idx];
	ml[mf.idx] = tml;
#endif

	for (lc = 0; lc < n; lc++) {
		dml[lc] = ml[lc];
	}

#ifdef EX4SIMD
	// Parallelize code


#endif

	// main loop
	fline = 0;
	rline = m;
	for (fline = 0; fline < n; fline++) {
		double coefficient;
		double *factor, *subject;

		factor = ml[fline].focus;
		assert (factor[0] != 0);

		// LU main
		for (sline = fline + 1; sline < n; sline++) {
			subject = ml[sline].focus;
			coefficient = subject[0] / factor[0];
			
			//printf("coefficient = %lf, focus: f=%p, s=%p \n", coefficient, factor, subject);

			for (lc = 0; lc < rline; lc++) {
				subject[lc] -= coefficient * factor[lc];
				//printf("%d: f=%lf, s=%lf\n", lc, factor[lc], subject[lc]); 
			}

			subject[0] = coefficient;
			ml[sline].focus++;

		}



		rline--;
		// Seek PIVOT
		pivot = fline+1;
#ifdef EX4PIVOT
		mf.max = ml[pivot].focus;
		mf.idx = pivot;
		for (lc = pivot + 1; lc < n; lc++) {
			if(*(mf.max) < *(ml[lc].focus)) {
				mf.max = ml[lc].focus;
				mf.idx = lc;
			}
		}

		// PIVOT
		tml = ml[pivot];
		ml[pivot] = ml[mf.idx];
		ml[mf.idx] = tml;
#endif



	}
}
