#include <spu_mfcio.h>
#include <mt19937ar.h>

#define SPE_STOP  0
#define SPE_START 1
#define SPE_DONE  2

typedef struct {
  volatile double *result_p;
  volatile int flag;
  long int random_seed;
  int size;
} dma_data_t;
static volatile dma_data_t dma_data __attribute__ ((aligned(128)));

int main(unsigned long long spu_id, unsigned long long arg)
{
    int i;
    int dma_size;
    double result[2048] __attribute__ ((aligned(128)));

    //printf("wait initialize data...\n");
    do {
        spu_mfcdma32((volatile void *) &dma_data, arg & 0xffffffff,
                     sizeof(dma_data_t), 1, MFC_GET_CMD);
        spu_writech(MFC_WrTagMask, 1 << 1);
        spu_mfcstat(MFC_TAG_UPDATE_ALL);
    } while (dma_data.flag == SPE_STOP);

    //    printf("start job\n");
    init_genrand(dma_data.random_seed);


    /* gen random  */
    for (i = 0; i < dma_data.size; i++) {
      result[i] = genrand_real1() * 100.0;
    }


    //printf("start sending\n");
    spu_mfcdma32((volatile void *) &result,
                 ((unsigned int) dma_data.result_p) & 0xffffffff,
                 sizeof(double)*dma_data.size, 1, MFC_PUT_CMD);

    //printf("wait sending...\n");
    spu_writech(MFC_WrTagMask, 1 << 1);
    spu_mfcstat(MFC_TAG_UPDATE_ALL);

    dma_data.flag = SPE_DONE;

    //printf("renewal dma_data\n");

    spu_mfcdma32((volatile void *) &dma_data, arg & 0xffffffff,
                 sizeof(dma_data_t), 1, MFC_PUT_CMD);
    spu_writech(MFC_WrTagMask, 1 << 1);
    spu_mfcstat(MFC_TAG_UPDATE_ALL);

    //printf("exit spu thread.\n");

    return 0;
}
